<?php

namespace App\Controller;

use App\Entity\Bibliography;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\JsonResponse;
use Symfony\Component\Routing\Attribute\Route;
use Doctrine\ORM\EntityManagerInterface;
use App\Entity\Finding;
use App\Entity\Image;

class FindingController extends AbstractController
{
    #[Route('/finding', name: 'app_finding')]
    public function index(EntityManagerInterface $em): JsonResponse
    {
        $repo = $em->getRepository(Finding::class);

        $findings = $repo->findAll();

        foreach($findings as $key => $finding) {
            $coords = $repo->coordinates($finding->getId());
            $finding->setLat($coords['lat']);
            $finding->setLng($coords['lng']);
            $findings[$key] = $finding;
        }

        return $this->json($findings);
    }

    #[Route('/finding/{id<\d+>}', name: 'app_finding_record')]
    public function record(Finding $finding, EntityManagerInterface $em): JsonResponse
    {
        $repo = $em->getRepository(Finding::class);
        $coords = $repo->coordinates($finding->getId());
        $finding->setLat($coords['lat']);
        $finding->setLng($coords['lng']);
        $repo = $em->getRepository(Bibliography::class);
        $biblio = $repo->findAllByFinding($finding->getId());
        $repo = $em->getRepository(Image::class);
        $images = $repo->findBy(
            ['finding' => $finding->getId()],
            ['sequence' => 'ASC']
        );

        $finding->setBibliography($biblio);
        $finding->setImages($images);

        return $this->json($finding);
    }
}
