<?php

namespace App\Controller;

use App\Entity\NotConserved;
use App\Entity\Bibliography;
use App\Entity\Document;
use App\Entity\Image;
use Doctrine\ORM\EntityManagerInterface;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\JsonResponse;
use Symfony\Component\Routing\Attribute\Route;

class NotConservedController extends AbstractController
{
    #[Route('/not_conserved', name: 'app_not_conserved')]
    public function index(EntityManagerInterface $em): JsonResponse
    {
        $repo = $em->getRepository(NotConserved::class);
        //$repoBib = $em->getRepository(Bibliography::class);
        $repoImg = $em->getRepository(Image::class);
        
        $records = $repo->findBy([], ['id' => 'ASC']);

        // Terrible? N+1..
        foreach ($records as $key => $record) {
            $id = $record->getId();
            $record->setLat($repo->coordinates($id)['lat']);
            $record->setLng($repo->coordinates($id)['lng']);
            //$biblio = $repoBib->findAllByNotConserved($id);
            //$record->setBibliographies($biblio);
            $images = $repoImg->findBy(
                ['notConserved' => $record->getId()],
                ['sequence' => 'ASC']
            );

            $record->setImages($images);
            $records[$key] = $record;
        }

        return $this->json([
                'message' => 'All records for not conserved archaeological assets',
                'records' => $records
            ],
        );
    }

    #[Route('/not_conserved/{id<\d+>}', name: 'app_not_conserved_record')]
    public function record(NotConserved $notConserved, EntityManagerInterface $em): JsonResponse
    {
        $repo = $em->getRepository(NotConserved::class);
        $coordinates = $repo->coordinates($notConserved->getId());
        $repo = $em->getRepository(Bibliography::class);

        $biblio = $repo->findAllByNotConserved($notConserved->getId());
        $repo = $em->getRepository(Document::class);
        $documents = $repo->findByNotConserved($notConserved->getId());
        $notConserved->setBibliographies($biblio);
        $notConserved->setDocuments($documents);

        $notConserved->setLat($coordinates['lat']);
        $notConserved->setLng($coordinates['lng']);
        $repo = $em->getRepository(Image::class);
        $images = $repo->findBy(
            ['notConserved' => $notConserved->getId()],
            ['sequence' => 'ASC']
        );

        $notConserved->setImages($images);
        
        return $this->json($notConserved);
    }
}
